@if ($authenticatedUser(); as user) {
  <div
    class="full-width full-height flex-column overflow-hidden admin-workspace-grid-container p-b-30"
  >
    <div class="flex-fixed-size flex-row">
      <span class="admin-workspace-secondary-title m-l-50">
        {{ 'sqtm-core.generic.label.permission-matrix' | translate }}
      </span>
      @if (user.admin) {
        <div class="flex-fixed-size flex-row admin-workspace-grid-toolbar">
          <div class="flex-grow"></div>
          <div
            class="flex-fixed-size"
            [attr.data-test-toolbar-id]="'permissions-matrix-toolbar'"
          >
            <i></i>
          </div>
        </div>
      }
    </div>
    <div class="flex-row full-width full-height">
      <sqtm-app-profile-workspace-anchors></sqtm-app-profile-workspace-anchors>
      <div
        class="flex-column full-width overflow-hidden sqtm-large-grid-container p-10 m-l-10 permissions-matrix-container"
      >
        <div class="full-width flex-fixed-size flex-row button-bar">
          <i
            class="flex-fixed-size current-workspace-button action-icon-size m-l-5 m-t-5"
            nz-icon
            [nzType]="'sqtm-core-generic:zoom-in'"
            nz-tooltip
            [nzTooltipTitle]="'sqtm-core.generic.label.expand-all' | translate"
            nzTooltipPlacement="top"
            [attr.data-test-element-id]="'open-all-entity-types'"
            (click)="openAllPanels()"
          ></i>
          <i
            class="flex-fixed-size current-workspace-button action-icon-size m-l-5 m-t-5"
            nz-icon
            [nzType]="'sqtm-core-generic:zoom-out'"
            nz-tooltip
            [nzTooltipTitle]="
              'sqtm-core.generic.label.collapse-all' | translate
            "
            nzTooltipPlacement="top"
            [attr.data-test-element-id]="'close-all-entity-types'"
            (click)="closeAllPanels()"
          ></i>
          <sqtm-core-text-research-field
            [attr.data-test-element-id]="'profile-filter-field'"
            (newResearchValue)="search($event)"
            class="m-l-15 sqtm-core-multi-research-field"
          >
          </sqtm-core-text-research-field>
        </div>

        @if ($profilesAndPermissions(); as profilesAndPermissions) {
          <div id="permissions-matrix" class="overflow-auto">
            <table
              id="permissions-table"
              [style.width]="getTableWidth()"
              class="m-b-10 sqtm-core-prevent-selection"
            >
              <thead>
                <tr>
                  <th class="permissions-first-column"></th>
                  @for (
                    profileAndPermissions of profilesAndPermissions;
                    track profileAndPermissions
                  ) {
                    <th
                      [class]="getHeaderClasses(profileAndPermissions.active)"
                      (click)="
                        handleClickOnColumn(profileAndPermissions.profileId)
                      "
                      draggable="true"
                      [attr.data-profile-id]="profileAndPermissions.profileId"
                      (dragstart)="
                        onDragStart(
                          $event,
                          profileAndPermissions.profileName,
                          profileAndPermissions.profileId
                        )
                      "
                      (dragover)="
                        onDragOver($event, profileAndPermissions.profileId)
                      "
                      (drop)="onDrop($event, profileAndPermissions.profileName)"
                    >
                      @if (profileAndPermissions.active) {
                        <span>{{ profileAndPermissions.profileName }}</span>
                      } @else {
                        <span
                          nz-tooltip
                          [nzTooltipTitle]="
                            'sqtm-core.administration-workspace.profiles.label.inactive-profile'
                              | translate
                          "
                          nzTooltipPlacement="top"
                          >{{ profileAndPermissions.profileName }}</span
                        >
                      }
                    </th>
                  }
                </tr>
              </thead>
              <tbody>
                @for (panel of panels; track panel) {
                  <ng-container
                    *ngTemplateOutlet="
                      workspaceRowTemplate;
                      context: {
                        profileAndPermissions: profilesAndPermissions,
                        index: $index,
                        panelId: panel.id
                      }
                    "
                  ></ng-container>
                  @for (permission of panel.permissions; track permission) {
                    <ng-container
                      *ngTemplateOutlet="
                        rootPermissionRowTemplate;
                        context: {
                          profileAndPermissions: profilesAndPermissions,
                          $implicit: permission,
                          panelId: panel.id
                        }
                      "
                    ></ng-container>
                    @for (
                      subPermission of permission.permissions;
                      track subPermission
                    ) {
                      <ng-container
                        *ngTemplateOutlet="
                          subPermissionRowTemplate;
                          context: {
                            profileAndPermissions: profilesAndPermissions,
                            $implicit: subPermission,
                            permissionId: permission.id,
                            panelId: panel.id
                          }
                        "
                      ></ng-container>
                    }
                  }
                }
              </tbody>
            </table>
            <span #emptyTableMessage class="hide-permission">{{
              'sqtm-core.grid.empty-grid.label' | translate
            }}</span>
          </div>
        }
      </div>
    </div>
  </div>
}

<ng-template
  #workspaceRowTemplate
  let-profilesAndPermissions="profileAndPermissions"
  let-index="index"
  let-panelId="panelId"
>
  <tr
    (click)="collapsePanel(panelId)"
    [class]="getPanelTitleClasses(panelId, index)"
    [id]="panelId"
  >
    <td class="p-l-5 permission-title">
      <span
        nz-icon
        nzType="down"
        nzTheme="outline"
        class="permissions-workspace-anchor anchor-open"
      ></span>
      <i
        nz-icon
        nzTheme="fill"
        nzType="{{ getWorkspaceIcon(panelId) }}"
        class="font-15-px m-l-5"
      >
      </i>
      <span class="m-l-10 workspace-title">{{ getPanelTitle(panelId) }}</span>
    </td>
    @for (
      profileAndPermissions of profilesAndPermissions;
      track profileAndPermissions
    ) {
      <td class="permissions-line-table-header"></td>
    }
  </tr>
</ng-template>

<ng-template
  #rootPermissionRowTemplate
  let-profilesAndPermissions="profileAndPermissions"
  let-permission
  let-panelId="panelId"
>
  <tr class="permissions-line-table" [attr.data-panel-workspace]="panelId">
    <td
      class="p-l-5 permission-label"
      [attr.data-permission]="getPermissionCode(panelId, permission.id)"
      [attr.data-workspace]="panelId"
    >
      <span>{{ getPermissionLabel(panelId, permission.id) }}</span>
      @if (permission.explainMessage) {
        <i
          nz-icon
          nzType="sqtm-core-generic:help"
          nzTheme="outline"
          nz-tooltip
          [nzTooltipTitle]="permission.explainMessage"
          class="current-workspace-button tooltip-icon table-icon-size m-l-5 m-t-2"
        >
        </i>
      }
    </td>
    @for (
      profileAndPermissions of profilesAndPermissions;
      track profileAndPermissions
    ) {
      <td
        class="permissions-cell-table"
        [attr.data-profile-id]="profileAndPermissions.profileId"
      >
        @if (hasPermission(profileAndPermissions, panelId, permission.id)) {
          <span class="checked-icon">&#x2714;</span>
        }
      </td>
    }
  </tr>
</ng-template>

<ng-template
  #subPermissionRowTemplate
  let-profilesAndPermissions="profileAndPermissions"
  let-subPermission
  let-permissionId="permissionId"
  let-panelId="panelId"
>
  <tr class="permissions-line-table" [attr.data-panel-workspace]="panelId">
    <td
      class="p-l-20 sub-permission-label"
      [attr.data-parent-permission]="getPermissionCode(panelId, permissionId)"
      [attr.data-permission]="subPermission.id"
      [attr.data-workspace]="panelId"
    >
      <div class="sub-permission-border">
        <span>{{ getPermissionLabel(panelId, subPermission.id) }}</span>
        @if (subPermission.explainMessage) {
          <i
            nz-icon
            nzType="sqtm-core-generic:help"
            nzTheme="outline"
            nz-tooltip
            [nzTooltipTitle]="subPermission.explainMessage"
            class="current-workspace-button tooltip-icon table-icon-size m-l-5 m-t-2"
          >
          </i>
        }
      </div>
    </td>
    @for (
      profileAndPermissions of profilesAndPermissions;
      track profileAndPermissions
    ) {
      <td
        class="permissions-cell-table"
        [attr.data-profile-id]="profileAndPermissions.profileId"
      >
        @if (hasPermission(profileAndPermissions, panelId, subPermission.id)) {
          <span class="checked-icon">&#x2714;</span>
        }
      </td>
    }
  </tr>
</ng-template>
